#include "neopop.h"

#ifdef __GFXRENDER_1__

#include "neopop.h"
#include "mem.h"
#include "gfx.h"

#ifndef __ZODIAC__

#include "types.h"



//extern "C" {


#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpfont.h"

#include "gpstdio.h"
#include "gpmem.h"
#include "gpmm.h"


//}

#include "gpmain.h"

#endif

typedef	unsigned int	uint;



// modif du 25/06/03 by ThunderZ
// -> bon je viens de reprend la version couleur car je m'emelais les pinceaux sur le noir et blanc
//    comme ca ca sera plus facil ;)


//Original code by ThunderZ,LOCK...



// ##### SECTION POKE

/*Info:
	Pas oublier : Adressage screen GP32 de haut en bas puis prochaine colonne


ide :

	traitement par ligne :
	pour les 64 sprites 
	
	ecriture actuelle back to foreground
	regarder si gain pour la mthode d'ecriture foreground to back
		avec masque ecran... en cours
	
*/ 


// Reverse 0
// r0 = 7643210
// r1 = (r0>>4)|(r0<<4)	32107654

// Masquage de la line
// Bit  1 = pixel disponible

static _u8	linemask[32];	//To be inited with byte 0x55...


__inline void NewDrawTileLine(void* _screen, _u8 posx, _u16 tile, void* _pal, int mirror )
{
  _u16* screen 	= (_u16*)_screen;
  _u16* pal		= (_u16*)_pal;
  // For transparent pixels -> Blur the two bits per pixel to enhance check
  int	tilesolid = tile|(tile>>1);


/*	//Get the colour of the pixel
	if (pal_hi)
		data8 = palette_ptr[4 + index];
	else
		data8 = palette_ptr[0 + index];

	r = (data8 & 7) << 1;
	g = (data8 & 7) << 5;
	b = (data8 & 7) << 9;

	if (negative)
		cfb_scanline[x] = (r | g | b);
	else
		cfb_scanline[x] = ~(r | g | b);
}
*/

// pal_hi == tile

/*	//Get the colour of the pixel
	if (pal_hi)
		data8 = palette_ptr[4 + index];
	else
		data8 = palette_ptr[0 + index];

	r = (data8 & 7) << 1;
	g = (data8 & 7) << 5;
	b = (data8 & 7) << 9;

	if (negative)
		cfb_scanline[x] = (r | g | b);
	else
		cfb_scanline[x] = ~(r | g | b);
}
*/


	  posx&=0xFF;
	  if ( posx<=0xF8 )
	  {
		  screen+=(_u16)posx;
		  
		  // Forward / Positive
		  if (!mirror)
		  {
			if ( tilesolid&0x4000 )
				screen[0] = pal[(tile>>14)&3];
			if ( tilesolid&0x1000 )
				screen[1] = pal[(tile>>12)&3];
			if ( tilesolid&0x0400 )
				screen[2] = pal[(tile>>10)&3];
			if ( tilesolid&0x0100 )
				screen[3] = pal[(tile>>8)&3];
			if ( tilesolid&0x0040 )
				screen[4] = pal[(tile>>6)&3];
			if ( tilesolid&0x0010 )
				screen[5] = pal[(tile>>4)&3];
			if ( tilesolid&0x0004 )
				screen[6] = pal[(tile>>2)&3];
			if ( tilesolid&0x0001 )
				screen[7] = pal[(tile>>0)&3];
		  }
		  else //Backward / Positive
		  {
			if ( tilesolid&0x4000 )
				screen[7-0] = pal[(tile>>14)&3];
			if ( tilesolid&0x1000 )
				screen[7-1] = pal[(tile>>12)&3];
			if ( tilesolid&0x0400 )
				screen[7-2] = pal[(tile>>10)&3];
			if ( tilesolid&0x0100 )
				screen[7-3] = pal[(tile>>8)&3];
			if ( tilesolid&0x0040 )
				screen[7-4] = pal[(tile>>6)&3];
			if ( tilesolid&0x0010 )
				screen[7-5] = pal[(tile>>4)&3];
			if ( tilesolid&0x0004 )
				screen[7-6] = pal[(tile>>2)&3];
			if ( tilesolid&0x0001 )
				screen[7-7] = pal[(tile>>0)&3];
		  }
		}
		else
	    {
		  // Forward / Positive
		  if (!mirror)
		  {
			if ( tilesolid&0x4000 )
				screen[posx] = pal[(tile>>14)&3];
			posx=(posx+1)&0xFF;
			if ( tilesolid&0x1000 )
				screen[posx] = pal[(tile>>12)&3];
			posx=(posx+1)&0xFF;
			if ( tilesolid&0x0400 )
				screen[posx] = pal[(tile>>10)&3];
			posx=(posx+1)&0xFF;
			if ( tilesolid&0x0100 )
				screen[posx] = pal[(tile>>8)&3];
			posx=(posx+1)&0xFF;
			if ( tilesolid&0x0040 )
				screen[posx] = pal[(tile>>6)&3];
			posx=(posx+1)&0xFF;
			if ( tilesolid&0x0010 )
				screen[posx] = pal[(tile>>4)&3];
			posx=(posx+1)&0xFF;
			if ( tilesolid&0x0004 )
				screen[posx] = pal[(tile>>2)&3];
			posx=(posx+1)&0xFF;
			if ( tilesolid&0x0001 )
				screen[posx] = pal[(tile>>0)&3];
		  }
		  else //Backward / Positive
		  {
			posx=(posx+7)&0xFF;
			if ( tilesolid&0x4000 )
				screen[posx] = pal[(tile>>14)&3];
			posx=(posx-1)&0xFF;
			if ( tilesolid&0x1000 )
				screen[posx] = pal[(tile>>12)&3];
			posx=(posx-1)&0xFF;
			if ( tilesolid&0x0400 )
				screen[posx] = pal[(tile>>10)&3];
			posx=(posx-1)&0xFF;
			if ( tilesolid&0x0100 )
				screen[posx] = pal[(tile>>8)&3];
			posx=(posx-1)&0xFF;
			if ( tilesolid&0x0040 )
				screen[posx] = pal[(tile>>6)&3];
			posx=(posx-1)&0xFF;
			if ( tilesolid&0x0010 )
				screen[posx] = pal[(tile>>4)&3];
			posx=(posx-1)&0xFF;
			if ( tilesolid&0x0004 )
				screen[posx] = pal[(tile>>2)&3];
			posx=(posx-1)&0xFF;
			if ( tilesolid&0x0001 )
				screen[posx] = pal[(tile>>0)&3];
		  }
		 }
		
}

static __inline void DrawPlaneLine( void* _screen, int pos, void* _tiles, void* _basetiles, void* _basepalettes, int row )
{
	_u16	tile;
	int		reverse;
	_u16*	ptile;
	_u16*	pal;

	_u16*	screen 		= (_u16*)_screen;
	_u16* 	tiles		= (_u16*)_tiles;
	_u16*	basetiles	= (_u16*)_basetiles; 
	_u16*	basepalettes = (_u16*)_basepalettes;
	int		i;
	//int		base;
	
	
	//Draw plane line
	for ( i=0; i<32; i++ )
	{
		pos&0xFF;
		


		tile 	= *tiles++;
		if ( pos<winw )
		{
			reverse = (tile&0x4000)?7:0;
			ptile 	= basetiles+((tile&0x01FF)<<3)+(row^reverse);
//			pal		= basepalettes+(((tile&0x1E00)>>9)<<2);
		// (data16 & 0x1E00) >> 9
		//		data16 & 0x2000
			pal		= basepalettes+((tile&0x2000)<<2);
			NewDrawTileLine( screen, pos, *ptile, pal, tile&0x8000 );
		}
		pos+=8;
	}
}

// ##### END SECTION POKE


static __inline void gfx_draw_scroll1()
{
	int		line			= scanline + scroll1y;
	_u16*	basetiles 		= (_u16*)(ram + 0xA000);
	_u16*	tiles 			= (_u16*)(ram + 0x9000);
	_u16*   basepalettes 	= (_u16*)(ram + 0x8108);
	
	tiles += 4*(line&0xF8);
//	tiles += (line&0xF8) << 2;
	
	DrawPlaneLine( cfb_scanline, -scroll1x, tiles, basetiles, basepalettes, line&7 );
}

static __inline void gfx_draw_scroll2()
{
	int		line			= scanline + scroll2y;
	_u16*	basetiles 		= (_u16*)(ram + 0xA000);
	_u16*	tiles 			= (_u16*)(ram + 0x9800);
	_u16*   basepalettes 	= (_u16*)(ram + 0x8110);
	
	tiles += 4*(line&0xF8);
//	tiles += (line&0xF8) << 2;
	
	DrawPlaneLine( cfb_scanline, -scroll2x, tiles, basetiles, basepalettes, line&7 );
}


// Tables des sorts....

static  _u8		backspr[64*4];
static  _u8		midspr[64*4];
static  _u8		topspr[64*4];

// Sprite sorting...
static void gfx_sprite_sort(void)
{
    _u8* 	spr2;
	uint 	priority;
    _u32	data16;
    _u8		y;
    _u8		x;
    _u8	 	lastSpriteY;
    _u8	 	lastSpriteX;

	_u8*	pbackspr = backspr;
	_u8*	pmidspr  = midspr;
	_u8*	ptopspr  = topspr;
	
//	_u32*	spr2 = (_u32*)(_u8*)ram[0x88FC];
	
	// Pour les 64 sprites...

	_u8*	psprA = ram + 0x8800;
	_u8*	pspr  = ram + 0x8800 + 0xFC;
//	_u8		spr	  = 0;
		
    while ( pspr>=psprA )
    {	
    	data16		= *((_u32*)pspr)--;

    	//spr2 		= ram + 0x8800 + (spr << 2);
		//data16 		= *(_u16*)(spr2);
		priority 	= (data16 >> 11)&3;

        //calcul positionnement Y
	    y = (data16>>24);  //Y position
        if (data16 & 0x0200)
           y += lastSpriteY;  //Vertical chain?
        lastSpriteY = y;
        y += scrollspry;
        //Ce sprite est dans les bornes ?
		y = scanline-y;
        if ( y&0xF8 )	//Pas visible sur cette ligne
        	continue;
		// Flip Y
		if ( data16&0x4000 )
			y ^= 7;
	        
        //calcul positionnement Y
	    x = data16>>16;   //X position
        if (data16 & 0x0400)
           x += lastSpriteX; //Horizontal chain?
        lastSpriteX = x;
        x += scrollspry;
        	
        // On stocke l'ordre
        if ( priority==1 )
        {
        	*pbackspr++ = (pspr+4-psprA)>>2;
        	*pbackspr++ = x;
        	*pbackspr++ = y;
        }
        else if ( priority==2 )
        {
        	*pmidspr++ = (pspr+4-psprA)>>2;
        	*pmidspr++ = x;
        	*pmidspr++ = y;
        }
        else if ( priority==3 )
        {
        	*ptopspr++ = (pspr+4-psprA)>>2;
        	*ptopspr++ = x;
        	*ptopspr++ = y;
        }
	}
	*pbackspr = 255;
	*pmidspr  = 255;
	*ptopspr  = 255;
}

// Afficher un sprite par ligne...
__inline void DrawLineSprite( _u8 idspr, _u8 x, _u8 row )
{
	_u8*	pspr;
	_u8*	ppalsel;
	_u8*	pbitmap;
	_u8*	ppals;
	_u16	hspr;

	// Handle du sprite
	pspr	= ram+0x8800+((idspr<<2)&0xFC);
	hspr	= *(_u16*)pspr;
	
	//Selection de palette
	ppalsel	= pspr+0x2000;//+idspr; //pspr+0x2000; //ram+0x8C00+idspr;
//	ppals	= ram+0x8100+(((*ppalsel)&0xF)<<3);
	ppals	= ram+0x8100+((*ppalsel)<<3);
	
	//Adresse de base des bitmap
	pbitmap	= ram+0xA000+((hspr&0x1FF)*16)+(row*2);
//	pbitmap	= ram+0xA000+((hspr&0x1FF) << 4)+(row << 1);
	
	NewDrawTileLine( cfb_scanline, x, *(_u16*)pbitmap,	ppals, hspr&0x8000 );
}

void gfx_draw_scanline_mono(void)
{
  int	x;
  int 	i;
  _u8* 	ramOff7 = (ram + 0x8100);//(ram + 0x8200);
  int	maxx;
  _u16*	fptr;
  _u16*	fptrend;
  int	fillcnt;
  _u16*	fillptr;
  _u16	filldata16;
  _u32	filldata32;
  
  _u8*	pbackspr = backspr;
  _u8*	pmidspr  = midspr;
  _u8*	ptopspr  = topspr;
  _u8	idspr;

  //Get the current scanline
  scanline = ram[0x8009];
  
  
  cfb_scanline = cfb + ((uint)scanline<<7) + ((uint)scanline<<5);  //Calculate fast offset (*160)

// ATTENTION ENLEVER

  //Window colour
	r = (_u16)oowc << 1;
	g = (_u16)oowc << 5;
	b = (_u16)oowc << 9;
	
	if (negative)
		filldata16 = (r | g | b);
	else
		filldata16 = ~(r | g | b);


/*
  //Top
  if (scanline < winy) {
    for (x = 0; x < SCREEN_WIDTH; x++)
      cfb_scanline[x] = data16;
  }
  else {
    //Middle
    if (scanline < winy + winh) {
      for (x = 0; x < min(winx, SCREEN_WIDTH); x++)
        cfb_scanline[x] = data16;

      for (x = min(winx + winw, SCREEN_WIDTH); x < SCREEN_WIDTH; x++)
        cfb_scanline[x] = data16;
    }
    else {
      //Bottom
      for (x = 0; x < SCREEN_WIDTH; x++)
        cfb_scanline[x] = data16;
    }
  }
*/

  //Ignore above and below the window's top and bottom
  if ( scanline >= winy && scanline < winy + winh) {
		//Background colour Enabled?
		if ((bgc & 0xC0) == 0x80)
		{
			r = (_u16)(bgc & 7) << 1;
			g = (_u16)(bgc & 7) << 5;
			b = (_u16)(bgc & 7) << 9;
			filldata16 = ~(r | g | b);
		}
		else filldata16 = 0x0FFF;

		if (negative) filldata16 = ~filldata16;


	// On tri les sprites...
	gfx_sprite_sort();
	
  //Draw background!
    fillcnt 	= min(winx+winw, SCREEN_WIDTH)-winx;
    filldata32 	= (((int)filldata16)<<16)|filldata16;
    fillptr		= cfb_scanline+winx;
    
    if ( ((int)fillptr)&2 )
    {
    	*((_u16*)fillptr)++ = filldata16;
    	fillcnt--;
    }
    while (fillcnt>=8)
    {
    	*((_u32*)fillptr)++ = filldata32;
    	*((_u32*)fillptr)++ = filldata32;
    	*((_u32*)fillptr)++ = filldata32;
    	*((_u32*)fillptr)++ = filldata32;
	    fillcnt-=8;
    }
    while (fillcnt>0)
    {
    	*((_u16*)fillptr)++ = filldata16;
    	fillcnt--;
    }
  	
  
  /*
    maxx = min(winx + winw, SCREEN_WIDTH);
    for (x = winx; x < maxx; x++)
      cfb_scanline[x] = filldata16;
      */

	// Background sprites
    while ( (idspr=*pbackspr++)!=255 )
    {
    	_u8		x		= *pbackspr++;
    	_u8		y		= *pbackspr++;
        DrawLineSprite(idspr,x,y);
    }

	// Plane background
	if (planeSwap)
	   gfx_draw_scroll1();
	else
	   gfx_draw_scroll2();

	// Middle sprites
    while ( (idspr=*pmidspr++)!=255 )
    {
    	_u8		x		= *pmidspr++;
    	_u8		y		= *pmidspr++;
        DrawLineSprite(idspr,x,y);
    }

	//Plane foreground
	if (!planeSwap)
	   gfx_draw_scroll1();
	else
	   gfx_draw_scroll2();

	// Top sprites
    while ((idspr=*ptopspr++)!=255 )
    {
    	_u8		x		= *ptopspr++;
    	_u8		y		= *ptopspr++;
        DrawLineSprite(idspr,x,y);
    }

  }
}
#endif
