

#ifndef __DMA__
#define __DMA__
//=============================================================================

void reset_dma(void);

void DMA_update(int channel);

extern _u32 dmaS[4], dmaD[4];
extern _u16 dmaC[4];
extern _u8 dmaM[4];

_u8  dmaLoadB(_u8 cr);
_u16 dmaLoadW(_u8 cr);
_u32 dmaLoadL(_u8 cr);

void dmaStoreB(_u8 cr, _u8 data);
void dmaStoreW(_u8 cr, _u16 data);
void dmaStoreL(_u8 cr, _u32 data);

//=============================================================================
#endif
