#include "types.h"
//extern "C" {
#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpfont.h"

#include "gpstdio.h"
#include "gpmem.h"
#include "gpmm.h"
//}

#include "gpmain.h"

#include "TZ_Lib.h"


#include "file_dialog.h"

#include "gfxlib.h"
#include "bioslib.h"
#include "gp32.h"
#include "gp32_font.h"


//extern GPDRAWSURFACE gpDrawSurface[2];
//extern int nflip;
extern unsigned char *vrambuffer,*currentbuffer;
extern struct LCDinfo lcd;

extern void gp32_GpTextOut(uint8 *buffer,int X,int Y,char *A,int col,int bold);

extern uint16 halfval[65536];
extern uint16 minval[65536];

unsigned char *screen_map;


void DebounceKey()
{
 char key;

 key=GpKeyGet();
 
 while (key!=0) key=GpKeyGet();
}

int MenuSelection=0;
int Menucyp=0;
int Menucyi=0;

#define Cls(Col) \
  gm_memset(currentbuffer,Col,320*240*2);

int DoLoader(GPDIRENTRY *MDL, ulong DIRCOUNT)
{
	char key;
    char file_en_cour[100];
int i,m,l;


//	GPDRAWTAG rect;

//	rect.clip_x = 0;
//	rect.clip_y = 60;//0;
//	rect.clip_w = GPC_LCD_WIDTH;
//	rect.clip_h = 160;//GPC_LCD_HEIGHT; //210;

	while (GpKeyGet());

	while (1)
	{
//		Cls(COLOR_WHITE);
       Cls_Menu();

//#define LCD_PUT_PIXEL(x, y, color)	\
//	gpSurface[(x) * LCD_PHYSICAL_W + LCD_PHYSICAL_W - (y) - 1] = color;
	
		if (DIRCOUNT>2)
		{
			for (i=0;i<DIRCOUNT-2;i++)
			{
				if (((i*12)-(Menucyp/12)+115+12>0) && ((i*12)-(Menucyp/12)+115+12<240))
          		{
          			if (i==MenuSelection-2)
          			{
//     		    		GpTextOut16(&rect, &gpDrawSurface[nflip], 112, (i*12)-(Menucyp/12)+115, (char*)&MDL[i+2].name, COLOR_BLACK);
//     		    		GpTextOut16(&rect, &gpDrawSurface[nflip], 112-1, (i*12)-(Menucyp/12)+115-1, (char*)&MDL[i+2].name, COLOR_BLUE);
                       if((i*12)-(Menucyp/12)+115>50)
                       {

                		for (m=0;m<12;m++)
                        {
                			for (l=0;l<320;l++)
                            {
//              				((unsigned short *)vrambuffer)[(240+12-(m+119))+(l*240)]=halfval[((unsigned short *)vrambuffer)[(240+12-(m+119))+(l*240)]];
                				((unsigned short *)vrambuffer)[(240+12-(m+(i*12)-(Menucyp/12)+115+10))+(l*240)]=halfval[((unsigned short *)vrambuffer)[(240+12-(m+(i*12)-(Menucyp/12)+115+10))+(l*240)]];
                //		    		screen_map[(240+12-(m+119))+(l*240)]=0;
                            }
                        }


//     		    		gp32_GpTextOut(vrambuffer, 112, (i*12)-(Menucyp/12)+115, (char*)&MDL[i+2].name, COLOR_BLACK,1);

//     		    		gp32_GpTextOut(vrambuffer, 112-1, (i*12)-(Menucyp/12)+115-1, (char*)&MDL[i+2].name, COLOR_BLUE,1);
     		    		gp32_GpTextOut(vrambuffer, 112-1, (i*12)-(Menucyp/12)+115-1, (char*)&MDL[i+2].name, (12<<11)|(31<<6)|(12<<1)|1,1);

                       }
	                }
                    else
			    	{
//     		    		GpTextOut16(&rect, &gpDrawSurface[nflip], 112, (i*12)-(Menucyp/12)+115, (char*)&MDL[i+2].name, COLOR_BLACK);
//			    		GpTextOut16(&rect, &gpDrawSurface[nflip], 112-1, (i*12)-(Menucyp/12)+115-1, (char*)&MDL[i+2].name, COLOR_WHITE);
                       if((i*12)-(Menucyp/12)+115>50)
                       {
//     		    		gp32_GpTextOut(vrambuffer, 112, (i*12)-(Menucyp/12)+115, (char*)&MDL[i+2].name, COLOR_BLACK,0);

//			    		gp32_GpTextOut(vrambuffer, 112-1, (i*12)-(Menucyp/12)+115-1, (char*)&MDL[i+2].name, COLOR_WHITE,1);
			    		gp32_GpTextOut(vrambuffer, 112-1, (i*12)-(Menucyp/12)+115-1, (char*)&MDL[i+2].name, (26<<11)|(26<<6)|(26<<1)|1,1);


                       }
					}
               }
 			}
		}

		key=GpKeyGet();
  		
		if (!(key & GPC_VK_UP) && !(key & GPC_VK_DOWN))
		{
			Menucyi=0;
			Menucyp=Menucyp/144;
			Menucyp=Menucyp*144;
		}

		if (key & GPC_VK_DOWN)
		{
			if (Menucyi==0)
				Menucyp+=6*12;

			Menucyi+=2;

			if (Menucyi>128)
				Menucyi=128;
		}

		if (key & GPC_VK_UP)
		{
			if (Menucyi==0)
				Menucyp-=6*12;

			Menucyi-=2;

			if (Menucyi<-128)
				Menucyi=-128;
		}
		
		Menucyp=Menucyp+Menucyi;
		
		if (Menucyp<0)
			Menucyp=0;
		
		if (Menucyp>=((DIRCOUNT-3)*144))
			Menucyp=(DIRCOUNT-3)*144;

		MenuSelection=(Menucyp/144)+2;

		if (MenuSelection<2)
			MenuSelection=2;
		
		if (MenuSelection>=DIRCOUNT)
			MenuSelection=DIRCOUNT-1;

        if (key & GPC_VK_FA)
		{
			DebounceKey();
			return MenuSelection;
		}

        if (key & GPC_VK_FB)
		{
			DebounceKey();
			return MenuSelection;
		}

        if (key & GPC_VK_SELECT)
		{
			DebounceKey();
			return MenuSelection;
		}


       gp_str_func.sprintf(file_en_cour,"Rom selected is : %s",MDL[MenuSelection].name);
//   	   GpTextOut16(NULL, &gpDrawSurface[nflip], 60, 26, file_en_cour, COLOR_BLACK);
//   	   GpTextOut16(NULL, &gpDrawSurface[nflip], 60-1, 26-1, file_en_cour, COLOR_YELLOW);
       DrawWindow(40, 15 , 300-60,20, COLOR_GREEN);
//   	   gp32_GpTextOut(vrambuffer, 60, 22, file_en_cour, COLOR_BLACK,1);
   	   gp32_GpTextOut(vrambuffer, 60-1, 22-1, file_en_cour, COLOR_GREEN,1);


    	//flip and show hidden surface		
//		GpSurfaceFlip(&gpDrawSurface[nflip++]);
//	  	nflip %= 2;	
        FlipAndShow();
	}
}
